// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax --opt --turbo-filter=*

function foo() {
  with ({ value:"fooed" }) { return value; }
}

v8PrepareFunctionForOptimization(foo);
v8OptimizeFunctionOnNextCall(foo);
assertEquals("fooed", foo());
assertOptimized(foo);

function bar() {
  with ({ value:"bared" }) { return value; }
}

v8PrepareFunctionForOptimization(bar);
assertEquals("bared", bar());
v8OptimizeFunctionOnNextCall(bar);
assertEquals("bared", bar());
assertOptimized(bar);
