// Copyright 2019 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax --opt --no-always-opt

function call(cb) {
  return cb.call(this, 42);
}

function bar() {
  function foo(arg) {
    v8TurbofanStaticAssert(arg === 42);
    return v8IsBeingInterpreted();
  }
  v8PrepareFunctionForOptimization(foo);

  return call(foo);
}


v8PrepareFunctionForOptimization(bar);
v8PrepareFunctionForOptimization(call);
assertTrue(bar());
assertTrue(bar());
v8OptimizeFunctionOnNextCall(bar);
assertFalse(bar());
